<html>
<head>
<title>Create User Account</title>
<SCRIPT TYPE="text/ssperl" CGI='$LOGINTICKET $REMOTE_ADDR $LOGINUSERNAME $LOGINIPADDRESS $LOGINPATH'>
	::create_login_file("~/Private/.Passwords", "~/Private/.Sessions", $REMOTE_ADDR);	
	"";
</SCRIPT>
<SCRIPT type="text/javascript" LANGUAGE="JavaScript">
<SCRIPT TYPE="text/ssperl" SRC="./JavaScript/CreateUserPage.js"></SCRIPT>
</script>

</head>
<body>
<p>
<table width='100%'><tr>
	<td style='text-align: left'><a href="/index.html">Home</a></td> 
	<td style='text-align: right'><a href="?LOGOUT">Logout</a></td>
</tr></table>
</p>
<p ALIGN=RIGHT><a href="index.html">Private Home page</a><br />
<a href="ChangePassword.html">Change Password</a><br />
<SCRIPT TYPE="text/ssperl" CGI='@CAPABILITIES $LOGINUSERNAME'>
	# Block access to 
	if($ENV{'EnforceCreateUser'} && ! grep(/^CreateUser$/, @CAPABILITIES))
	{
		my $banner = "";
		$banner =<< "ENDOFNOAUTHORIZATION BANNER";
<h1 style="text-align: center; color: Red">$LOGINUSERNAME: You are not authorized to create a new user account</h1>
<h2 style="text-align: center; color: Red">Please contact your administrator</h2>

</body>
</html>
ENDOFNOAUTHORIZATION BANNER

		print STDOUT $banner;
		exit;
	};
	"";
</SCRIPT>
	
<h1 align=CENTER>Create new user account</h1>
<SCRIPT TYPE="text/ssperl" CGI='$NEWACCOUNTTEXT'>
if($NEWACCOUNTTEXT =~ /\S/)
{
	my $filename = "";
	if($NEWACCOUNTTEXT =~ /Username\:\s+([^\n]+)(\n|$)/isg)
	{
		$filename = lc($1);
		$filename =~ s/[^\w]/_/isg;
	};
	print STDOUT << "ENDOFPRINTNEWACCOUNTTEXT";
Paste this text into a file with name <em>$filename</em>
<pre>
$NEWACCOUNTTEXT
</pre>
ENDOFPRINTNEWACCOUNTTEXT
};
"";
</SCRIPT>

</pre>
<p>
<form method="POST" action="CreateUser.html" id="LoginForm"
	onSubmit='CreateUserSubmit ()'>
<div style="margin-left: 20%; margin-right: 20%; text-align: left">
<table cellspacing="5" >
	<tr>
		<td style="text-align: right">Password:</td>
		<td style="text-align: left"><input type="PASSWORD" name="PASSWORD" id="PASSWORD" size="50" /></td>
	</tr>
	<tr><td>&nbsp;</td><td>&nbsp;</td></tr>
	<tr><td>&nbsp;</td><td>New user account settings</td></tr>
	
	<tr>
		<td style="text-align: right">New Username:</td>
		<td style="text-align: left">
			<input type="text" name="NEWUSERNAME" id="NEWUSERNAME" size="30" />
		</td>
	</tr>
	<tr>
		<td style="text-align: right">New Password:</td>
		<td style="text-align: left"><input type="PASSWORD" name="NEWPASSWORD" id="NEWPASSWORD" size="50" />
	</td>
	<tr>
		<td style="text-align: right">Repeat Password:</td>
		<td style="text-align: left"><input type="PASSWORD" name="NEWPASSWORDREP" id="NEWPASSWORDREP" size="50" onChange="check_password_fields();"/></td>
 	</tr>
	<tr>
		<td style="text-align: right"></td>
		<td style="text-align: left">Account Settings</td>
 	</tr>
	<tr>
		<td style="text-align: right">Allowed Paths:</td>
		<td style="text-align: left"><input type="TEXT" name="ALLOWEDPATHS" id="ALLOWEDPATHS" size="50" value="# ; separated perl regex" /></td>
 	</tr>
	<tr>
		<td style="text-align: right">Allowed IP addresses:</td>
		<td style="text-align: left"><input type="TEXT" name="IPADDRESS" id="IPADDRESS" size="50" value="127.0.0.1;# Other (partial) IP addresses" /></td>
 	</tr>
	<tr>
		<td style="text-align: right">Capabilities:</td>
		<td style="text-align: left"><input type="TEXT" name="NEWCAPABILITIES" id="NEWCAPABILITIES" size="50" value="# Space separated list of names" /></td>
 	</tr>
	<tr>
		<td style="text-align: right">Session type:</td>
		<td style="text-align: left">
			<select name="NEWSESSION" id="NEWSESSION">
				<option value ="SESSION" selected>SESSION</option>
				<option value ="CHALLENGE">CHALLENGE</option>
				<option value ="IPADDRESS">IPADDRESS</option>
			</select>
		</dt>
	</tr>
	<tr><td>&nbsp;</td><td>&nbsp;</td></tr>
	<tr>
		<td></td>
		<td style="text-align: left"><input type="submit" id="SUBMIT" value="Create" style="color: Gray" />
		<input type="button" id="revealpassword" value="Show Passwords" onClick="this.value=togglePasswords('Hide', 'Show', this.value);true" /></td>
	</tr>
</table>
  <input type="hidden" name="CGIUSERNAME" id="CGIUSERNAME" size="20" value=<SCRIPT type="text/ssperl">$LOGINUSERNAME</SCRIPT> />
  <input type="hidden" name="LOGINTICKET" id="LOGINTICKET" value="--" />
</div>
</form>
</p>
<h2 align=CENTER>Strong Passwords: It is so easy</h2>
<h3 align=CENTER>If you only could see what you are typing</h3>
<p style="margin-left: 20%; margin-right: 20%; text-align: center">
<a href="http://xkcd.com/936/" target="_blank"><img src="http://imgs.xkcd.com/comics/password_strength.png" width="60%" /></a>
</p>
<p style="margin-left: 30%; margin-right: 30%; text-align: center">
<font style="font-size: small">
<em>
	Note: For the procedures used at this site, a basic computer setup can check a billion passwords per second. You need
	a password (or phrase) strength in the order of 56 bits to be a little secure (one year on a single computer). One of 
	the largest network in the world, Bitcoin mining, can check some 12 terahashes per second (June 2012). This 
	corresponds to checking 6 times 10<sup>12</sup> passwords per second. 
	It would take a passwords strength of ~68 bits to keep the equivalent of 
	the Bitcoin computer network occupied for around a year before it found 
	a match.<br />
	An example whould be the phrase '</em>Sherlock investigates oleander curry in Bath<em>'.
</em>
</font>
</p>
<p style="margin-left: 30%; margin-right: 30%; text-align: justify">
Your password might be vulnerable to <a href=
"https://en.wikipedia.org/wiki/Brute_force_attack"><em>brute force
</em></a> guessing. Protections against such attacks are costly in 
terms of code complexity, bugs, and execution time.<br /> However, 
there is a very simple and secure counter measure. See the <a href=
"http://xkcd.com/936/" target="_blank">XKCD comic</a> above. The 
phrase, <em>There is no password like more password</em> would be 
both much easier to remember, and still stronger than <em>h4]D%@m:49
</em>, at least before this phrase was pasted as an example on the 
Internet.<br /> Please be so kind and add the name of your favorite 
flower, dish, fictional character, or small town to your password. 
Say, <em>Oleander</em>, <em>Curry</em>, <em>Sherlock</em>, or 
<em>Bath</em>, UK (each adds ~12 bits) or even the phrase 
<em>Sherlock investigates oleander curry in Bath</em> (adds &gt; 56 bits, 
note that oleander is <em>poisonous</em>, so do not try this curry at home). 
That would be more effective than adding a thousand rounds of encryption. 
Typing long passwords without seeing what you are typing is problematic. 
So a button should be included to make password visible. 
</p>
<p>
	<hr>
</p>
<p>
The Salt and Ticket values are all created using SHA256 on 64 Byte of output from <em>/dev/urandom</em> in HEX.
</p>
<FONT STYLE="font-size:small">
<p> Example Login page for CGIscriptor.pl<br />
    Copyright &copy; 2012  R.J.J.H. van Son<br />
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.<br />
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <a href="http://www.gnu.org/licenses/">http://www.gnu.org/licenses/</a>.
</p>
<p> A JavaScript implementation of the SHA family of hashes, as defined in FIPS
	PUB 180-2 as well as the corresponding HMAC implementation as defined in
	FIPS PUB 198a<br />
	Version 1.3 Copyright Brian Turek 2008-2010
	Distributed under the BSD License<br />
	See <a href="http://jssha.sourceforge.net/">http://jssha.sourceforge.net/</a> for more information<br />
	Several functions taken from Paul Johnson
</p>
</FONT>

</body>
</html>
